diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelBrazier.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelBrazier.java
index aff52d9ca..5130dd287 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelBrazier.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelBrazier.java
@@ -7,10 +7,13 @@ import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogicBrazier;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.util.helper.Side;
-import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.primitives.AABBd;
+import org.joml.primitives.AABBdc;
 import org.lwjgl.opengl.GL11;
 
 public class BlockModelBrazier<T extends BlockLogicBrazier>
@@ -24,29 +27,30 @@ public class BlockModelBrazier<T extends BlockLogicBrazier>
     }
 
     @Override
-    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, int x, int y, int z) {
+    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
+        TilePos queryPos = new TilePos();
         tessellator.setColorOpaque_I(0xFFFFFF);
 
         renderBlocks.enableAO = true;
-        renderBlocks.cache.setupCache(block, worldSource, x, y, z);
-        AABB bounds = block.getBounds();
-        renderBlocks.renderSide(tessellator, worldSource, this, bounds, x, y, z, 1, 1, 1, Side.NORTH, 0);
-        renderBlocks.renderSide(tessellator, worldSource, this, bounds, x, y, z, 1, 1, 1, Side.SOUTH, 0);
-        renderBlocks.renderSide(tessellator, worldSource, this, bounds, x, y, z, 1, 1, 1, Side.EAST, 0);
-        renderBlocks.renderSide(tessellator, worldSource, this, bounds, x, y, z, 1, 1, 1, Side.WEST, 0);
-        renderBlocks.renderSide(tessellator, worldSource, this, bounds, x, y, z, 1, 1, 1, Side.BOTTOM, 0);
+        renderBlocks.cache.setupCache(this.block, worldSource, tilePos);
+        AABBd bounds = new AABBd(this.block.getBounds());
+        renderBlocks.renderSide(tessellator, worldSource, this, bounds, tilePos, 1, 1, 1, Side.NORTH, 0);
+        renderBlocks.renderSide(tessellator, worldSource, this, bounds, tilePos, 1, 1, 1, Side.SOUTH, 0);
+        renderBlocks.renderSide(tessellator, worldSource, this, bounds, tilePos, 1, 1, 1, Side.EAST, 0);
+        renderBlocks.renderSide(tessellator, worldSource, this, bounds, tilePos, 1, 1, 1, Side.WEST, 0);
+        renderBlocks.renderSide(tessellator, worldSource, this, bounds, tilePos, 1, 1, 1, Side.BOTTOM, 0);
 
         final double zFightOffset = 0.005;
-        bounds.set(-zFightOffset, -zFightOffset, -zFightOffset, 1 + zFightOffset, 1 + zFightOffset, 1 + zFightOffset);
-        renderBlocks.renderSide(tessellator, worldSource, this, bounds, x, y, z + 1, 0, 0, 0, Side.NORTH, 0);
-        renderBlocks.renderSide(tessellator, worldSource, this, bounds, x, y, z - 1, 0, 0, 0, Side.SOUTH, 0);
-        renderBlocks.renderSide(tessellator, worldSource, this, bounds, x - 1, y, z, 0, 0, 0, Side.EAST, 0);
-        renderBlocks.renderSide(tessellator, worldSource, this, bounds, x + 1, y, z, 0, 0, 0, Side.WEST, 0);
-        renderBlocks.renderSide(tessellator, worldSource, this, bounds, x, y - 1, z, 0, 0, 0, Side.TOP, 0);
+        bounds.setMin(-zFightOffset, -zFightOffset, -zFightOffset).setMax(1 + zFightOffset, 1 + zFightOffset, 1 + zFightOffset);
+        renderBlocks.renderSide(tessellator, worldSource, this, bounds, tilePos.south(queryPos), 0, 0, 0, Side.NORTH, 0);
+        renderBlocks.renderSide(tessellator, worldSource, this, bounds, tilePos.north(queryPos), 0, 0, 0, Side.SOUTH, 0);
+        renderBlocks.renderSide(tessellator, worldSource, this, bounds, tilePos.west(queryPos), 0, 0, 0, Side.EAST, 0);
+        renderBlocks.renderSide(tessellator, worldSource, this, bounds, tilePos.east(queryPos), 0, 0, 0, Side.WEST, 0);
+        renderBlocks.renderSide(tessellator, worldSource, this, bounds, tilePos.down(queryPos), 0, 0, 0, Side.TOP, 0);
         renderBlocks.enableAO = false;
 
-        if (block.getLogic().isBurning()) {
-            fireModel.render(tessellator, worldSource, x, y, z);
+        if (this.block.getLogic().isBurning()) {
+            this.fireModel.render(tessellator, worldSource, tilePos);
         }
 
         return true;
@@ -54,66 +58,66 @@ public class BlockModelBrazier<T extends BlockLogicBrazier>
 
     @Override
     public void renderStandalone(@NotNull Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate) {
-        AABB bounds = block.getBounds();
+        AABBdc bounds = this.block.getBounds();
         GL11.glTranslatef(-0.5F, -0.5F, -0.5F);
 
         GL11.glColor4f(brightness, brightness, brightness, alpha);
 
         tessellator.startDrawingQuads();
         tessellator.setNormal(0.0F, -1F, 0.0F);
-        renderBlocks.renderBottomFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, baseTexture);
+        renderBlocks.renderBottomFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, this.baseTexture);
         tessellator.draw();
 
         tessellator.startDrawingQuads();
         tessellator.setNormal(0.0F, 1.0F, 0.0F);
-        renderBlocks.renderTopFace(tessellator, bounds, 0.0D, -1.0D, 0.0D, baseTexture);
+        renderBlocks.renderTopFace(tessellator, bounds, 0.0D, -1.0D, 0.0D, this.baseTexture);
         tessellator.draw();
 
         tessellator.startDrawingQuads();
         tessellator.setNormal(0.0F, 0.0F, -1F);
-        renderBlocks.renderNorthFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, sideTexture);
+        renderBlocks.renderNorthFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, this.sideTexture);
         tessellator.draw();
 
         tessellator.startDrawingQuads();
         tessellator.setNormal(0.0F, 0.0F, -1F);
-        renderBlocks.renderNorthFace(tessellator, bounds, 0.0D, 0.0D, 1.0D, sideTexture);
+        renderBlocks.renderNorthFace(tessellator, bounds, 0.0D, 0.0D, 1.0D, this.sideTexture);
         tessellator.draw();
 
         tessellator.startDrawingQuads();
         tessellator.setNormal(0.0F, 0.0F, 1.0F);
-        renderBlocks.renderSouthFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, sideTexture);
+        renderBlocks.renderSouthFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, this.sideTexture);
         tessellator.draw();
 
         tessellator.startDrawingQuads();
         tessellator.setNormal(0.0F, 0.0F, 1.0F);
-        renderBlocks.renderSouthFace(tessellator, bounds, 0.0D, 0.0D, -1.0D, sideTexture);
+        renderBlocks.renderSouthFace(tessellator, bounds, 0.0D, 0.0D, -1.0D, this.sideTexture);
         tessellator.draw();
 
         tessellator.startDrawingQuads();
         tessellator.setNormal(-1F, 0.0F, 0.0F);
-        renderBlocks.renderWestFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, sideTexture);
+        renderBlocks.renderWestFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, this.sideTexture);
         tessellator.draw();
 
         tessellator.startDrawingQuads();
         tessellator.setNormal(-1F, 0.0F, 0.0F);
-        renderBlocks.renderWestFace(tessellator, bounds, 1.0D, 0.0D, 0.0D, sideTexture);
+        renderBlocks.renderWestFace(tessellator, bounds, 1.0D, 0.0D, 0.0D, this.sideTexture);
         tessellator.draw();
 
         tessellator.startDrawingQuads();
         tessellator.setNormal(1.0F, 0.0F, 0.0F);
-        renderBlocks.renderEastFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, sideTexture);
+        renderBlocks.renderEastFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, this.sideTexture);
         tessellator.draw();
 
         tessellator.startDrawingQuads();
         tessellator.setNormal(1.0F, 0.0F, 0.0F);
-        renderBlocks.renderEastFace(tessellator, bounds, -1.0D, 0.0D, 0.0D, sideTexture);
+        renderBlocks.renderEastFace(tessellator, bounds, -1.0D, 0.0D, 0.0D, this.sideTexture);
         tessellator.draw();
 
         GL11.glTranslatef(0.5F, 0.5F, 0.5F);
     }
 
     @Override
-    public boolean shouldSideBeRendered(WorldSource blockAccess, AABB bounds, int x, int y, int z, @NotNull Side side) {
+    public boolean shouldSideBeRendered(@NotNull WorldSource source, @NotNull AABBdc bounds, @NotNull TilePosc tilePos, @NotNull Side side) {
         return true;
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelButtonPainted.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelButtonPainted.java
index d8fa8116d..dadade9ea 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelButtonPainted.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelButtonPainted.java
@@ -6,19 +6,21 @@ import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.Side;
+import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
 public class BlockModelButtonPainted<T extends BlockLogic> extends BlockModelStandard<T> {
     protected final IconCoordinate[] texCoords = new IconCoordinate[DyeColor.COLOR_AMOUNT];
+
     public BlockModelButtonPainted(final Block<T> block) {
         super(block);
-        for (final DyeColor c : DyeColor.blockOrderedColors()){
+        for (final DyeColor c : DyeColor.blockOrderedColors()) {
             this.texCoords[c.blockMeta] = TextureRegistry.getTexture("minecraft:block/planks/" + c.colorID);
         }
     }
 
     @Override
-    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(final Side side, final int meta) {
+    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(final @NotNull Side side, final int meta) {
         return this.texCoords[(meta >> 4) & DyeColor.MASK_COLOR];
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCactus.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCactus.java
index 55dd58cd8..2bb322c01 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCactus.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCactus.java
@@ -5,10 +5,12 @@ import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.util.helper.Side;
-import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.primitives.AABBd;
+import org.joml.primitives.AABBdc;
 import org.lwjgl.opengl.GL11;
 
 public class BlockModelCactus<T extends BlockLogic> extends BlockModelStandard<T> {
@@ -17,36 +19,36 @@ public class BlockModelCactus<T extends BlockLogic> extends BlockModelStandard<T
     }
 
     @Override
-    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, int x, int y, int z) {
+    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
         final float sidesOffset = 0.0625F;
 
-        AABB bounds = block.getBounds();
-        bounds.set(sidesOffset, 0, 0, 1 - sidesOffset, 1, 1);
+        AABBd bounds = new AABBd(this.block.getBounds());
+        bounds.setMin(sidesOffset, 0, 0).setMax(1 - sidesOffset, 1, 1);
         renderBlocks.setRenderSide(Side.SOUTH, false);
         renderBlocks.setRenderSide(Side.NORTH, false);
-        renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z);
+        renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, tilePos);
         renderBlocks.renderBitMask = 0b111111;
 
-        bounds.set(0, 0, sidesOffset, 1, 1, 1 - sidesOffset);
+        bounds.setMin(0, 0, sidesOffset).setMax(1, 1, 1 - sidesOffset);
         renderBlocks.setRenderSide(Side.SOUTH, true);
         renderBlocks.setRenderSide(Side.NORTH, true);
-        renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z);
+        renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, tilePos);
         renderBlocks.renderBitMask = 0;
 
         return true;
     }
+
     @Override
-    public void renderStandalone(@NotNull Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate){
-        if(renderBlocks.useInventoryTint)
-        {
-            int color = BlockColorDispatcher.getInstance().getDispatch(block).getFallbackColor(metadata, 0);
-            float r = (float)(color >> 16 & 0xff) / 255F;
-            float g = (float)(color >> 8 & 0xff) / 255F;
-            float b = (float)(color & 0xff) / 255F;
+    public void renderStandalone(@NotNull Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate) {
+        if (renderBlocks.useInventoryTint) {
+            int color = BlockColorDispatcher.getInstance().getDispatch(this.block).getFallbackColor(metadata, 0);
+            float r = (float) (color >> 16 & 0xff) / 255F;
+            float g = (float) (color >> 8 & 0xff) / 255F;
+            float b = (float) (color & 0xff) / 255F;
             GL11.glColor4f(r * brightness, g * brightness, b * brightness, alpha);
         }
 
-        AABB bounds = getBlockBoundsForItemRender();
+        AABBdc bounds = getBlockBoundsForItemRender();
         GL11.glTranslatef(-0.5F, -0.5F, -0.5F);
 
         final float sidesOffset = 0.0625F;
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCake.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCake.java
index 6086aa3ab..78244c2f9 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCake.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCake.java
@@ -5,10 +5,12 @@ import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.util.helper.Side;
+import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
 public class BlockModelCake<T extends BlockLogic> extends BlockModelStandard<T> {
     protected IconCoordinate cakeInner = TextureRegistry.getTexture("minecraft:block/cake/inner");
+
     public BlockModelCake(Block<T> block) {
         super(block);
         float f = 0.0625F;
@@ -17,11 +19,9 @@ public class BlockModelCake<T extends BlockLogic> extends BlockModelStandard<T>
     }
 
     @Override
-    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data)
-    {
-        if(data > 0 && side == Side.WEST)
-        {
-            return cakeInner;
+    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(@NotNull Side side, int data) {
+        if (data > 0 && side == Side.WEST) {
+            return this.cakeInner;
         }
         return super.getBlockTextureFromSideAndMetadata(side, data);
     }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCandle.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCandle.java
index eb60a4427..f390ed53b 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCandle.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCandle.java
@@ -6,6 +6,7 @@ import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 
 public class BlockModelCandle<T extends BlockLogic> extends BlockModelStandard<T> {
@@ -14,21 +15,20 @@ public class BlockModelCandle<T extends BlockLogic> extends BlockModelStandard<T
     }
 
     @Override
-    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, int x, int y, int z) {
-        boolean isLit = (worldSource.getBlockMetadata(x, y, z) & 0b00000001) == 0;
-        float brightness = isLit ? 1.0f : renderBlocks.getBlockBrightness(worldSource, x, y, z);
-
-        float minX = x + 0.5f - (1.5f / 16f);
-        float minY = y + 0f;
-        float minZ = z + 0.5f - (1.5f / 16f);
-        float maxX = x + 0.5f + (1.5f / 16f);
-        float maxY = y + 0.5f;
-        float maxZ = z + 0.5f + (1.5f / 16f);
+    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
+        boolean isLit = (worldSource.getBlockData(tilePos) & 0b00000001) == 0;
+        float brightness = isLit ? 1.0f : renderBlocks.getBlockBrightness(worldSource, tilePos);
+
+        float minX = tilePos.x() + 0.5f - (1.5f / 16f);
+        float minY = tilePos.y() + 0f;
+        float minZ = tilePos.z() + 0.5f - (1.5f / 16f);
+        float maxX = tilePos.x() + 0.5f + (1.5f / 16f);
+        float maxY = tilePos.y() + 0.5f;
+        float maxZ = tilePos.z() + 0.5f + (1.5f / 16f);
         float wickMaxY = maxY + (6f / 16f);
 
         IconCoordinate texIndex = getParticleTexture(Side.TOP, 0);
-        if(renderBlocks.overrideBlockTexture != null)
-        {
+        if (renderBlocks.overrideBlockTexture != null) {
             texIndex = renderBlocks.overrideBlockTexture;
         }
         double texU = texIndex.getIconUMin();
@@ -117,6 +117,7 @@ public class BlockModelCandle<T extends BlockLogic> extends BlockModelStandard<T
 
         return true;
     }
+
     @Override
     public boolean shouldItemRender3d() {
         return false;
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelChest.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelChest.java
index c0d8200ef..0dcb496d4 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelChest.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelChest.java
@@ -8,6 +8,7 @@ import net.minecraft.core.util.helper.Axis;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 import org.useless.dragonfly.DisplayPos;
@@ -26,17 +27,18 @@ public class BlockModelChest<T extends BlockLogic> extends BlockModelStandard<T>
     protected IconCoordinate chestTopRight;
     protected IconCoordinate chestSide;
     protected IconCoordinate chestTop;
+
     public BlockModelChest(Block<T> block, String rootKey) {
         super(block);
-        chestFrontSingle = TextureRegistry.getTexture(rootKey + "front");
-        chestFrontLeft = TextureRegistry.getTexture(rootKey + "left_front");
-        chestFrontRight = TextureRegistry.getTexture(rootKey + "right_front");
-        chestTopLeft = TextureRegistry.getTexture(rootKey + "top_left");
-        chestTopRight = TextureRegistry.getTexture(rootKey + "top_right");
-        chestBackLeft = TextureRegistry.getTexture(rootKey + "left_back");
-        chestBackRight = TextureRegistry.getTexture(rootKey + "right_back");
-        chestSide = TextureRegistry.getTexture(rootKey + "side");
-        chestTop = TextureRegistry.getTexture(rootKey + "top");
+        this.chestFrontSingle = TextureRegistry.getTexture(rootKey + "front");
+        this.chestFrontLeft = TextureRegistry.getTexture(rootKey + "left_front");
+        this.chestFrontRight = TextureRegistry.getTexture(rootKey + "right_front");
+        this.chestTopLeft = TextureRegistry.getTexture(rootKey + "top_left");
+        this.chestTopRight = TextureRegistry.getTexture(rootKey + "top_right");
+        this.chestBackLeft = TextureRegistry.getTexture(rootKey + "left_back");
+        this.chestBackRight = TextureRegistry.getTexture(rootKey + "right_back");
+        this.chestSide = TextureRegistry.getTexture(rootKey + "side");
+        this.chestTop = TextureRegistry.getTexture(rootKey + "top");
 
         setDisplayPos(DisplayPos.GUI, CHEST_GUI);
         setDisplayPos(DisplayPos.HEAD, CHEST_HEAD);
@@ -44,8 +46,8 @@ public class BlockModelChest<T extends BlockLogic> extends BlockModelStandard<T>
     }
 
     @Override
-    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, int x, int y, int z) {
-        int meta = worldSource.getBlockMetadata(x, y, z);
+    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
+        int meta = worldSource.getBlockData(tilePos);
         final Direction dir = BlockLogicChest.getDirectionFromMeta(meta);
         switch (dir) {
             case NORTH:
@@ -63,62 +65,62 @@ public class BlockModelChest<T extends BlockLogic> extends BlockModelStandard<T>
                 break;
         }
 
-        renderBlocks.renderStandardBlock(tessellator, worldSource, this, block.getBlockBoundsFromState(worldSource, x, y, z), x, y, z);
+        renderBlocks.renderStandardBlock(tessellator, worldSource, this, this.block.getBoundsFromState(worldSource, tilePos), tilePos);
         renderBlocks.resetRenderBlocks();
         return true;
     }
 
     @Override
-    public @Nullable IconCoordinate getBlockTexture(WorldSource blockAccess, int x, int y, int z, Side side) {
-        int meta = blockAccess.getBlockMetadata(x, y, z);
+    public @Nullable IconCoordinate getBlockTexture(@NotNull WorldSource source, @NotNull TilePosc tilePos, @NotNull Side side) {
+        int meta = source.getBlockData(tilePos);
 
         Side facing = BlockLogicChest.getDirectionFromMeta(meta).getSide();
         BlockLogicChest.Type type = BlockLogicChest.getTypeFromMeta(meta);
 
-        if(side == Side.TOP || side == Side.BOTTOM) {
-            if(type == BlockLogicChest.Type.RIGHT) {
-                return chestTopRight;
+        if (side == Side.TOP || side == Side.BOTTOM) {
+            if (type == BlockLogicChest.Type.RIGHT) {
+                return this.chestTopRight;
             }
-            if(type == BlockLogicChest.Type.LEFT) {
-                return chestTopLeft;
+            if (type == BlockLogicChest.Type.LEFT) {
+                return this.chestTopLeft;
             }
 
-            return chestTop;
+            return this.chestTop;
         }
 
-        if(type == BlockLogicChest.Type.SINGLE) {
-            if(side == facing) {
-                return chestFrontSingle;
+        if (type == BlockLogicChest.Type.SINGLE) {
+            if (side == facing) {
+                return this.chestFrontSingle;
             }
         }
 
-        if(type == BlockLogicChest.Type.LEFT) {
-            if(side == facing) {
-                return chestFrontLeft;
+        if (type == BlockLogicChest.Type.LEFT) {
+            if (side == facing) {
+                return this.chestFrontLeft;
             }
-            if(side == facing.getOpposite()) {
-                return chestBackRight;
+            if (side == facing.getOpposite()) {
+                return this.chestBackRight;
             }
         }
-        if(type == BlockLogicChest.Type.RIGHT) {
-            if(side == facing) {
-                return chestFrontRight;
+        if (type == BlockLogicChest.Type.RIGHT) {
+            if (side == facing) {
+                return this.chestFrontRight;
             }
-            if(side == facing.getOpposite()) {
-                return chestBackLeft;
+            if (side == facing.getOpposite()) {
+                return this.chestBackLeft;
             }
         }
-        if(side.getAxis() != Axis.Y) {
-            return chestSide;
+        if (side.getAxis() != Axis.Y) {
+            return this.chestSide;
         }
 
-        return chestTop;
+        return this.chestTop;
     }
 
     @Override
-    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data) {
-        if (side == Side.SOUTH) return chestFrontSingle;
-        if (side.isHorizontal()) return chestSide;
-        return chestTop;
+    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(@NotNull Side side, int data) {
+        if (side == Side.SOUTH) return this.chestFrontSingle;
+        if (side.isHorizontal()) return this.chestSide;
+        return this.chestTop;
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelChestPainted.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelChestPainted.java
index f2b7c1592..1179a1c46 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelChestPainted.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelChestPainted.java
@@ -9,6 +9,8 @@ import net.minecraft.core.util.helper.Axis;
 import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
 public class BlockModelChestPainted<T extends BlockLogic> extends BlockModelChest<T> {
@@ -43,8 +45,8 @@ public class BlockModelChestPainted<T extends BlockLogic> extends BlockModelChes
     }
 
     @Override
-    public @Nullable IconCoordinate getBlockTexture(WorldSource blockAccess, int x, int y, int z, Side side) {
-        int meta = blockAccess.getBlockMetadata(x, y, z);
+    public @Nullable IconCoordinate getBlockTexture(@NotNull WorldSource blockAccess, @NotNull TilePosc tilePos, @NotNull Side side) {
+        int meta = blockAccess.getBlockData(tilePos);
         int color = meta >> 4;
 
         Side facing = BlockLogicChest.getDirectionFromMeta(meta).getSide();
@@ -91,7 +93,7 @@ public class BlockModelChestPainted<T extends BlockLogic> extends BlockModelChes
     }
 
     @Override
-    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data) {
+    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(@NotNull Side side, int data) {
         int color = data >> 4;
         if (side == Side.SOUTH) return texCoords[color][TEX_SINGLE_FRONT];
         if (side.isHorizontal()) return texCoords[color][TEX_SIDE];
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCobbledNetherrack.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCobbledNetherrack.java
index 3ccfcec23..09d16022f 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCobbledNetherrack.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCobbledNetherrack.java
@@ -5,21 +5,27 @@ import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.util.helper.Axis;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
 public class BlockModelCobbledNetherrack<T extends BlockLogic> extends BlockModelStandard<T> {
-    private IconCoordinate ashSide = TextureRegistry.getTexture("minecraft:block/cobbled_netherrack/ashen_side");
+    private final IconCoordinate ashSide = TextureRegistry.getTexture("minecraft:block/cobbled_netherrack/ashen_side");
+
     public BlockModelCobbledNetherrack(Block<T> block) {
         super(block);
     }
 
     @Override
-    public IconCoordinate getBlockTexture(WorldSource blockAccess, int x, int y, int z, Side side) {
-        Material material = blockAccess.getBlockMaterial(x, y + 1, z);
-        if ((material == Material.topAsh || material == Material.ash) && (side.getAxis() != Axis.Y)) {
-            return ashSide;
-        } else return super.getBlockTexture(blockAccess, x, y, z, side);
+    public @Nullable IconCoordinate getBlockTexture(@NotNull WorldSource source, @NotNull TilePosc tilePos, @NotNull Side side) {
+        Material material = source.getBlockMaterial(tilePos.up(new TilePos()));
+        if ((material == Materials.TOP_ASH || material == Materials.ASH) && (side.getAxis() != Axis.Y)) {
+            return this.ashSide;
+        } else return super.getBlockTexture(source, tilePos, side);
     }
 }
